<?php

namespace LivraisonParSecteurs\Hook;

use LivraisonParSecteurs\LivraisonParSecteurs;
use Thelia\Core\Event\Hook\HookRenderBlockEvent;
use Thelia\Core\Event\Hook\HookRenderEvent;
use Thelia\Core\Hook\BaseHook;
use Thelia\Core\Security\AccessManager;
use Thelia\Core\Security\SecurityContext;

/**
 * Class AdminHook
 */
class AdminHook extends BaseHook
{
    protected $securityContext;

    public function __construct(SecurityContext $securityContext)
    {
        $this->securityContext = $securityContext;
    }

    public function onMainTopMenuTools(HookRenderEvent $event)
    {
        $isGranted = $this->securityContext->isGranted(
            ["ADMIN"],
            [],
            [LivraisonParSecteurs::getModuleCode()],
            [AccessManager::VIEW]
        );

        if ($isGranted) {
            $event->add($this->render("menu-hook.html", $event->getArguments()));
        }
    }


//    public function onModuleConfig(HookRenderEvent $event)
//    {
//        $isGranted = $this->securityContext->isGranted(
//            ["ADMIN"],
//            [],
//            [LivraisonParSecteurs::getModuleCode()],
//            [AccessManager::VIEW]
//        );
//
//        if ($isGranted) {
//            $event->add($this->render("deliveryarea-list.html", $event->getArguments()));
//        }
//    }


    /* Pour intégrer la date prévue de livraison dans différents formulaires (email, backOffice, ...) */
    public function displayDeliveryDate(HookRenderEvent $event)
    {

        $moduleId = $event->getArgument('module');
        $orderId = $event->getArgument('order_id');

        if ((null !== $orderId) && ($moduleId == LivraisonParSecteurs::getModuleId()))
        {
            $selectedDay = $this->getSession()->get(LivraisonParSecteurs::LPS_DELIVERY_DATE);
            $beginTime = $this->getSession()->get(LivraisonParSecteurs::LPS_DELIVERY_BEGIN_TIME);
            $endTime = $this->getSession()->get(LivraisonParSecteurs::LPS_DELIVERY_END_TIME);

            if ( (null !==  $selectedDay) && (null !==  $beginTime) && (null !==  $endTime) )
            {
                $event->add(
                    $this->render(
                        'delivery-address.html', [
                        'day' => $selectedDay,
                        'begin_time' => $beginTime,
                        'end_time' => $endTime
                    ])
                );
            }
        }
    }

    /* Pour afficher la liste des livraisons à effectuer dans la page d'accueil backOffice */
    public function displayScheduledDeliveries(HookRenderBlockEvent $event)
    {
        $content = trim($this->render("scheduled-deliveries.html"));
        if (!empty($content)) {
            $event->add([
                "id" => "block-scheduled-deliveries",
                "title" => $this->trans("Scheduled deliveries", [], LivraisonParSecteurs::DOMAIN_NAME),
                "content" => $content,
                "class" => "col-md-6"
            ]);
        }
    }

}
